#!/bin/sh

echo "ExperSHOP for Unix setup"
echo
echo "Welcome"
echo
echo "Documentation on how to use this product should be downloaded from www.experlog.com"
echo "Before you start this installation please ensure you have uninstalled all previous versions of ExperSHOP."
echo "If you experience any problems contact the ExperLog support: support@experlog.com"
echo
#Guess the installation directory
expershop_root_initial=`pwd`

#Confirm install directory
echo "Please enter the directory where ExperSHOP is installed [${expershop_root_initial}]: "
read expershop_root

if [ -z "$expershop_root" ]
then
	expershop_root=$expershop_root_initial
fi

#Create EShop.cfg file
if [ ! -f ${expershop_root}/shops/lite/EShop.unix ]
then
	echo "Could not locate ExperSHOP base configuration file (${expershop_root}/shops/lite/EShop.unix)."
	exit
fi
cp -f ${expershop_root}/shops/lite/EShop.unix ${expershop_root}/EShop.unix

#Check root directory exists and looks OK
if [ -d ${expershop_root}/shops/lite ]
then
	chmod -R 777 ${expershop_root}/shops/lite/system
	chmod -R 777 ${expershop_root}/shops/lite/tables
        mkdir -p ${expershop_root}/shops/lite/tmp
	chmod -R 777 ${expershop_root}/shops/lite/tmp
	chmod -R 777 ${expershop_root}/shops/lite/index
	sed "s|EXPERSHOP_ROOT|$expershop_root|" ${expershop_root}/EShop.unix > ${expershop_root}/EShop.tmp
	mv -f ${expershop_root}/EShop.tmp ${expershop_root}/EShop.cfg
	sed "s|EXPERSHOP_ROOT|$expershop_root|" ${expershop_root}/shops/lite/DemoShop.unix > ${expershop_root}/shops/lite/DemoShop.tmp
	mv -f ${expershop_root}/shops/lite/DemoShop.tmp ${expershop_root}/shops/lite/DemoShop.cfg
else
	echo "ExperSHOP is not installed at $expershop_root. Please try again."
	exit
fi

echo
echo "ExperSHOP setup complete"

